<script setup>
import { computed, ref } from "vue";
import { useStore } from "vuex";
import Modal from "@components/Template/ModalOverlay.vue";

// Connect to Store and Router
const store = useStore();

// setup client state for this view
store.dispatch("adaptor/reset");
store.dispatch("adaptor/getGames");

// Compute necessary Store values for Component
const games = computed(() => store.state.adaptor.games);

// Create local references
const deleteGameModal = ref({ visible: false, name: null });
const newGameModal = ref({ visible: false, name: null });

// Create local functions
function clickedNewGame() {
  const name = newGameModal.value.name;
  store.dispatch("adaptor/createGame", { name, template: "basic" }).then(
    () => (newGameModal.value.visible = false),
    (error) => console.error(error), // on name rejected
  );
}

function clickedDeleteGame(e, name) {
  deleteGameModal.value.name = name;
  deleteGameModal.value.visible = true; // show modal
}

function deleteGame() {
  store.dispatch("adaptor/deleteGame", deleteGameModal.value.name).then(() => {
    deleteGameModal.value.visible = false;
  });
}
</script>

<template>
  <div class="is-scroll-container">
    <div class="height-100 is-flex is-flex-direction-column is-justify-content-center is-align-items-center">
      <div class="is-flex is-flex-direction-column is-flex-wrap-wrap">
        <div
          v-for="game in games"
          :key="game.name"
          class="box is-interactive has-background-adaptor has-border mb-3"
          @click="$router.push({ name: 'Overview', params: { game: game.name } })"
        >
          <nav class="level is-align-items-flex-end">
            <div class="level-left">
              <div class="level-item is-flex-direction-column is-align-items-flex-start">
                <h4 class="title is-4 has-text-weight-semibold">
                  {{ game.name }}
                </h4>
                <span>
                  {{ new Date(game?.setup?.created_at).toDateString() }}
                </span>
              </div>
            </div>
            <div class="level-right pb-1 pl-2">
              <p class="level-item">
                <Icon :icon="'trash-2'" @click.stop="clickedDeleteGame($event, game.name)" />
              </p>
            </div>
          </nav>
        </div>
      </div>

      <div>
        <button class="button is-dark mt-2" @click="newGameModal.visible = true">CREATE NEW GAME</button>
      </div>
    </div>

    <Modal v-if="newGameModal.visible" :modal="newGameModal" @close-modal="newGameModal.visible = false">
      <template #header>NEW GAME</template>
      <label for="name">What shall we call your new game?</label>
      <input v-model="newGameModal.name" class="input" type="text" name="name" placeholder="name" />
      <template #footer>
        <button class="button is-primary m-1" @click="clickedNewGame">NEW GAME</button>
        <button class="button m-1" @click="newGameModal.visible = false">CANCEL</button>
      </template>
    </Modal>

    <Modal
      v-if="deleteGameModal.visible"
      :modal="deleteGameModal"
      :css-classes="['is-danger']"
      @close-modal="deleteGameModal.visible = false"
    >
      <template #header>DELETE GAME {{ deleteGameModal.name }}</template>
      Do you really want do delete this game?
      <template #footer>
        <button class="button is-danger m-1" @click="deleteGame">DELETE</button>
        <button class="button m-1" @click="deleteGameModal.visible = false">CANCEL</button>
      </template>
    </Modal>
  </div>
</template>
